Loading...
Searching...
No Matches
ScenePlugin Class Referenceabstract
Inheritance diagram for ScenePlugin:

## Public Types

enum | DefaultBehavior { Ignore , False , True }

## Signals

void | drawablesChanged ()

## Public Member Functions

| ScenePlugin (QObject *parent=nullptr)
virtual void | process (const QtGui::Molecule &molecule, Rendering::GroupNode &node)
virtual void | processEditable (const RWMolecule &molecule, Rendering::GroupNode &node)
virtual QString | name () const =0
virtual QString | description () const =0
virtual bool | isEnabled () const
virtual bool | isActiveLayerEnabled () const
virtual void | setEnabled (bool enable)
virtual bool | isApplicable () const
virtual QWidget * | setupWidget ()
virtual bool | hasSetupWidget () const
virtual DefaultBehavior | defaultBehavior () const

## Protected Attributes

PluginLayerManager | m_layerManager

## Member Enumeration Documentation

## DefaultBehavior

enum DefaultBehavior

Returns if this plugin should be considered in the default behavior, or it should reset to true or false.

## Member Function Documentation

## process()

virtual void process | ( | const QtGui::Molecule & | molecule,
|  | Rendering::GroupNode & | node )

virtual

Process the supplied atom, and add the necessary primitives to the scene.

## name()

virtual QString name | ( |  | ) | const

pure virtual

The name of the scene plugin, will be displayed in the user interface.

## description()

virtual QString description | ( |  | ) | const

pure virtual

A description of the scene plugin, may be displayed in the user interface.

## isEnabled()

virtual bool isEnabled | ( |  | ) | const

virtual

Returns true if the scene plugin has been enabled and is active.

## isActiveLayerEnabled()

virtual bool isActiveLayerEnabled | ( |  | ) | const

virtual

Returns true if the scene plugin has been enabled and is active in the active scene.

## setEnabled()

virtual void setEnabled | ( | bool | enable | ) |

virtual

Set the enabled state of the plugin (default should be false).

## isApplicable()

virtual bool isApplicable | ( |  | ) | const

virtual

Returns
  whether this plugin works with the current molecule. This is used to determine if the plugin should be enabled in the UI. For example, a plugin that only works with unit cells would return false if the current molecule does not include a unit cell.

## setupWidget()

virtual QWidget * setupWidget | ( |  | ) |

virtual

Returns
  the widget for plugin settings (e.g., colors, widths, etc.)

## hasSetupWidget()

virtual bool hasSetupWidget | ( |  | ) | const

virtual

This method exists to query without creating the widget.

Returns
  true if the plugin has a setup widget

The documentation for this class was generated from the following file:

- sceneplugin.h